#<profile4xi profile = "12" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "original_dir4xi.py">
#<abstract4xi abstract = "provides class OriginalDir4Xi"/>
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'init_original_dir4xi', 'get_original_dir4xi', 'set_original_dir4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools         
except:
    pass
try:                 # rare ones
    pass         
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import Process
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
from print4xi import print4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ORIGINAL_DIR4XI
#"
#/>
 
ORIGINAL_DIR4XI = os.path.abspath(os.getcwd()) 

# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "init-original-dir4xi" usage = "
#   initializes orginal directory to the current working directory
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------- 
def init_original_dir4xi(param=None):           
    '''
    init_original_dir4xi initializes orginal directory to the current working directory
    '''
    global ORIGINAL_DIR4XI 

    class2print = "init_original_dir4xi"
    method2print = "init_original_dir4xi"

    message2print = "{started" + "; init-original-dir4xi-started: " + str(init_original_dir4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
                                                                                                                    # <function init_original_dir4xi at 0x000000000437BBC8>; time: 01:41:17 02/18/11 Pacific Standard Time}
            
    message2print = "{passed" + "; param-passed-to-init-original-dir4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                                                                                                                    # None; time: 01:41:17 02/18/11 Pacific Standard Time}                 
            

    if param:
        ORIGINAL_DIR4XI = param
    else:
        ORIGINAL_DIR4XI = os.path.abspath(os.getcwd()) 

    message2print = "{initialized" + "; original-dir4xi-initialized-by-init-original-dir4xi to: " + str(ORIGINAL_DIR4XI)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                                                                                                                    # E:\Sw4Xi\Python32\Lib\multiprocessing4xi; time: 01:41:17 02/18/11 Pacific Standard Time}
             
    message2print = "{returning" + "; init-original-dir4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                                                                                                                    # 01:41:17 02/18/11 Pacific Standard Time}        

#</function4xi>
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "original-dir4xi" usage = "
#   1) from original_dir4xi import _original_dir4xi
#          original_dir4xi._original_dir4xi <--- refer via module
#          count2xi = next(_original_dir4xi._counter) <--- uses its methods
#
#   2) from original_dir4xi import original_dir4xi
#          original_dir4xi(). <--- returns _original_dir4xi 
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def original_dir4xi():          
    '''
    original_dir4xi returns orginal directory
    '''

    global ORIGINAL_DIR4XI

    class2print = "original_dir4xi"
    method2print = "original_dir4xi"


    message2print = "{started" + "; original-dir4xi-started: " + str(original_dir4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 

    message2print = "{returning" + "; original-dir4xi-returning-by-original-dir4xi: " + str(ORIGINAL_DIR4XI) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
               
            
    return ORIGINAL_DIR4XI
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-original-dir4xi" usage = "
#   from original_dir4xi import original_dir4xi
#        p2xi = get_original_dir4xi()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_original_dir4xi():          
    '''
    get_original_dir4xi returns orginal directory
    '''
    global ORIGINAL_DIR4XI 

    class2print = "get_original_dir4xi"
    method2print = "get_original_dir4xi"


    message2print = "{started" + "; get-original-dir4xi-started: " + str(get_original_dir4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
   
    message2print = "{returning" + "; original-dir4xi-returning-by-get-original-dir4xi: " + str(ORIGINAL_DIR4XI) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
              
      
    return ORIGINAL_DIR4XI         
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-original-dir4xi" usage = "
#   process4xi.py
#       Process4Xi(object):
#           _bootstrap(self):
#               set_original_dir4xi(self) 
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

def set_original_dir4xi(param=None):          
    '''
    set_original_dir4xi returns orginal directory
    '''
    global ORIGINAL_DIR4XI

    class2print = "set_original_dir4xi"
    method2print = "set_original_dir4xi"


    message2print = "{started" + "; set-original-dir4xi-started: " + str(set_original_dir4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
 
        
    message2print = "{passed" + "; param-passed-to-set-original-dir4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
   
                    
    if param is None:
        ORIGINAL_DIR4XI = os.path.abspath(os.getcwd())       

    else:
        ORIGINAL_DIR4XI = param
    
    message2print = "{set" + "; original-dir4xi-set-by-set-original-dir4xi to: " + str(ORIGINAL_DIR4XI)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{returning" + "; set-original-dir4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
             
#</function4xi>
         
        
# =================================================================================================
#<class4xi class = "OriginalDir4Xi" base = "object" child = "None" synopsis = "provides original dir services" usage = "multiprocessing"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class OriginalDir4Xi(object):
    '''
    OriginalDir4Xi provides original dir services
    '''        
    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('set_original_dir', 'get_original_dir',
                 'sense', 'reason', 'ace')          
    #"
    #/>
                                                                                                                                                                        

    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-OriginalDir4Xi" usage = "initializes OriginalDir4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self,param=None):
        '''
        initializes OriginalDir4Xi
        '''
        class2print = "OriginalDir4Xi"
        method2print = "__init__"

        message2print = "{started" + "; init-of-OriginalDir4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{passed" + "; param-passed-to-init-of-OriginalDir4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                          
        
        message2print = "{passing" + "; param-passing-to-init-original-dir4xi-by-init-of-OriginalDir4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{borning" + "; originaldir2xi-of-OriginalDir4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{inheriting" + "; object-inheriting-by-originaldir2xi-of-OriginalDir4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
                             
        message2print = "{passing" + "; param-passing-to-init-original-dir4xi-by-init-of-OriginalDir4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                                     
        
        init_original_dir4xi(param)

        message2print = "{performed" + "; init-original-dir4xi-performed-by-init-of-OriginalDir4Xi: " + str(init_original_dir4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
        message2print = "{inherited" + "; object-inherited-by-originaldir2xi-of-OriginalDir4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
          
        
        message2print = "{activated" + "; originaldir2xi-of-OriginalDir4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                 

        
        message2print = "{returning" + "; init-of-OriginalDir4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-original-dir-of-OriginalDir4Xi" usage = "returns original dir">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------        
    def get_original_dir(self):          
        '''
        get_original_dir4 returns original dir
        '''
        class2print = "OriginalDir4Xi"
        method2print = "get_original_dir"
        
        message2print = "{started" + "; get-original-dir-of-OriginalDir4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        message2print = "{returning" + "; get-original-dir4xi-function-returning-by-get-original-dir-of-OriginalDir4Xi: " + str(get_original_dir4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                         
        
        return get_original_dir4xi() 
           
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-original-dir-of-OriginalDir4Xi" usage = "sets original dir">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def set_original_dir(self,param):          
        '''
        set_original_dir4xi sets original dir
        '''
        class2print = "OriginalDir4Xi"
        method2print = "set_original_dir"
        
        message2print = "{started" + "; set-original-dir-of-OriginalDir4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{passed" + "; param-passed-to-set-original-dir-of-OriginalDir4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                   
                   
        message2print = "{passing" + "; param-passing-to-set-original-dir4xi-by-set-original-dir-of-OriginalDir4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                  
        set_original_dir4xi(param)          

        message2print = "{returning" + "; set-original-dir-of-OriginalDir4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
   
                                 
    #</methodize4xi>
                                           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-OriginalDir4Xi" usage = "senses OriginalDir4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses OriginalDir4Xi class objects
        '''

        
        class2print = 'OriginalDir4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-OriginalDir4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; originaldir4xi-sensing-by-sense-of-OriginalDir4Xi: " + str(OriginalDir4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-OriginalDir4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-originaldir4xi'] =  object 
        
     
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-OriginalDir4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            
        
        
      
        message2print = "{sensed" + "; originaldir4xi-sensed-by-sense-of-OriginalDir4Xi: " + str(OriginalDir4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-OriginalDir4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-OriginalDir4Xi" usage = "reasons OriginalDir4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons OriginalDir4Xi class objects
        '''
      
        
        class2print = 'OriginalDir4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-OriginalDir4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; originaldir4xi-reasoning-by-reason-of-OriginalDir4Xi: " + str(OriginalDir4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-OriginalDir4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; originaldir4xi-reasoned-by-reason-of-OriginalDir4Xi: " + str(OriginalDir4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-OriginalDir4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-OriginalDir4Xi" usage = "aces OriginalDir4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces OriginalDir4Xi class objects 
        '''
 
        
        
        class2print = 'OriginalDir4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-OriginalDir4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
           
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; originaldir4xi-acing-by-ace-of-OriginalDir4Xi: " + str(OriginalDir4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                 
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-OriginalDir4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                

        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; originaldir4xi-aced-by-ace-of-OriginalDir4Xi: " + str(OriginalDir4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-OriginalDir4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                           
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_original_dir4xi.txt
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of original_dir4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


